from ..config.models import BaseAppConfig as BaseAppConfig
from ..constants import APP_NAME as APP_NAME
from ..image import ImageAPI as ImageAPI
from .hookspec import AppHookSpecs as AppHookSpecs
from .image import placeholder as placeholder, unsplash as unsplash
from collections.abc import Callable as Callable
from pluggy import PluginManager

class AppPluginManager(PluginManager):
    def __init__(self, *args, **kwargs) -> None: ...
    def reset_cache(self) -> None: ...
    @property
    def image_api_names(self) -> tuple[str, ...]: ...
    @property
    def image_api_config_fields(self) -> dict: ...
    def get_image_api_context_manager(self, app_config: BaseAppConfig) -> ImageAPI: ...
    def get_backend_validator_func(self) -> Callable: ...

def get_plugin_manager() -> AppPluginManager: ...
